﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using apifon_sdk_csharp.com.apifon.sdk.model;
using apifon_sdk_csharp.com.apifon.sdk.model.request;
using apifon_sdk_csharp.com.apifon.sdk.resource;
using apifon_sdk_csharp.com.apifon.sdk.response;
using com.apifon.sdk;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.Examples
{
    class BounceExample
    {
        static void Main(string[] args)
        {
            Mookee.AddCredentials("token", "Your_Token", "Your_Secret_Key");
            Mookee.SetActiveCredential("token");

            BounceListResource bounceListResource = new BounceListResource();

            int choice = 1;

            while (choice != 0)
            {
                Console.WriteLine("------Menu------");
                Console.WriteLine("0.  Exit");
                Console.WriteLine("1.  Add a Subscriber to Bounce List");
                Console.WriteLine("2.  Get a Subscriber from Bounce List");
                Console.WriteLine("3.  Get subscribers from Bounce List");
                Console.WriteLine("4.  Remove a Subscriber from Bounce List");
                Console.Write("Choice: ");
                choice = Convert.ToInt32(Console.ReadLine());

                switch (choice)
                {
                    case 0:
                        break;

                    /**
                     * Add a Subscriber to Bounce List
                     * 
                     * Use BounceReason enum class in order to send an acceptable string to API.
                     */
                    case 1:
                        BounceRequestBuilder.BounceRequest bounceRequest = BounceRequestBuilder.getBounceRequestBuilder("306999999999",BounceReason.other.ToString()).build();
                        Uri bounceUri = bounceListResource.addBounceSubscriber(bounceRequest);
                        Console.WriteLine(bounceUri);

                        break;

                    /**
                    * Get a Subscriber from Bounce List
                    */
                    case 2:
                        BounceSingleQuery bounceSingleQuery = BounceSingleQuery.getBounceLookup("306999999999");
                        BounceResponse resp = bounceListResource.getBounceSubscriber(bounceSingleQuery);
                        PrintJson(resp);

                        break;

                    /**
                    * Get subscribers from Bounce List
                    * 
                    * * Use BounceReason and BounceType enum classes in order to send acceptable strings to API.
                    */
                    case 3:
                        PaginatedRequest bounceQueryBuilder = BounceQueryBuilder.getBuilder()
                            .withType(BounceType.MOBILE.ToString()) //optional
                            .withReason(BounceReason.other.ToString()) //optional
                            .build();
                        CollectionEntityResponse<BounceResponse> collection = bounceListResource.getBounceSubscribers(bounceQueryBuilder);
                        PrintJson(collection);

                        break;

                    /**
                    * Remove a Subscriber from Bounce List
                    */
                    case 4:
                        bounceListResource.removeBounceSubscriber("306999999999");

                        break;
                }
            }
        }

        public static void PrintJson(Object response)
        {
            String jsonString = JsonConvert.SerializeObject(response);
            Console.WriteLine(JsonHelper.FormatJson(jsonString));
        }
    }
}
