﻿using com.apifon.sdk.model;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace apifon_sdk_csharp.com.apifon.sdk.model
{
    [DataContract]
    public class ImRequest : SubscriberViewRequest
    {
        private string referenceId;
        private MessageContent message;
        private string callbackUrl;
        private string replyUrl;
        private List<IMChannel> imChannels;
        private string date;

        public ImRequest() { }

        [DataMember(Name = "reference_id")]
        public string ReferenceId
        {
            get { return referenceId; }
            set { referenceId = value; }
        }

        [DataMember(Name = "message")]
        public MessageContent MessageContent
        {
            get { return message; }
            set { message = value; }
        }

        [DataMember(Name = "callback_url")]
        public string CallbackUrl
        {
            get { return callbackUrl; }
            set { callbackUrl = value; }
        }

        [DataMember(Name = "reply_url")]
        public string ReplyUrl
        {
            get { return replyUrl; }
            set { replyUrl = value; }
        }

        [DataMember(Name = "im_channels")]
        public List<IMChannel> ImChannels
        {
            get { return imChannels; }
            set { imChannels = value; }
        }

        [DataMember(Name = "date")]
        public string Date
        {
            get { return date; }
            set { date = value; }
        }

        public void AddImChannel(IMChannel channel)
        {
            if(imChannels == null)
            {
                imChannels = new List<IMChannel>();
            }
            imChannels.Add(channel);
        }

        public override string GetBody()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented,
                            new JsonSerializerSettings
                            {
                                NullValueHandling = NullValueHandling.Ignore
                            });
        }

        public override string GetCreateBody()
        {
            throw new NotImplementedException();
        }

        public override string GetDeleteBody()
        {
            throw new NotImplementedException();
        }

        public override string GetReadBody()
        {
            throw new NotImplementedException();
        }

        public override string GetUpdateBody()
        {
            throw new NotImplementedException();
        }
    }
}
