﻿using com.apifon.sdk.model;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace apifon_sdk_csharp.com.apifon.sdk.model
{
    [DataContract]
    public abstract class SubscriberViewRequest : IRequest
    {

        private List<SubscriberInformation> subscribers = new List<SubscriberInformation>();

        [DataMember(Name = "subscribers")]
        public List<SubscriberInformation> Subscribers
        {
            get { return subscribers; }
            set { subscribers = value; }
        }

        public void AddSubscribers(List<SubscriberInformation> subs)
        {
            foreach (var sub in subs)
            {
                subscribers.Add(sub);
            }

        }

        public void AddSubscriber(SubscriberInformation sub)
        {
            subscribers.Add(sub);
        }

        public void AddStrSubscribers(List<string> subs)
        {
            foreach (var sub in subs)
            {
                var subscriber = new SubscriberInformation();
                subscriber.Number = sub;
                subscribers.Add(subscriber);
            }

        }

        public void AddStrSubscriber(string sub)
        {
            var subscriber = new SubscriberInformation();
            subscriber.Number = sub;
            subscribers.Add(subscriber);
        }

        public abstract string GetBody();

        public abstract string GetCreateBody();

        public abstract string GetReadBody();

        public abstract string GetUpdateBody();

        public abstract string GetDeleteBody();
    }
}
