﻿using apifon_sdk_csharp.com.apifon.sdk.helpers;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.model.request
{
    public class BounceSingleQuery : IFieldSerializable<BounceSingleQuery>
    {
        private readonly string destination;
        private readonly HashSet<string> fields;

        private BounceSingleQuery(string destination)
        {
            this.destination = destination;
            this.fields = new HashSet<string>();
        }

        public static BounceSingleQuery getBounceLookup(string destination)
        {
            if (string.IsNullOrEmpty(destination)) { throw new System.ArgumentNullException("Parameter destination is null."); }
            return new BounceSingleQuery(destination);
        }

        public HashSet<string> getFields()
        {
            return this.fields;
        }

        public string getPathId()
        {
            return this.destination;
        }

        public BounceSingleQuery addVisibleFields(Collection<string> fields)
        {
            if (fields == null) { throw new System.ArgumentNullException("Parameter fields is null."); }
            this.getFields().UnionWith(fields);
            return this;
        }

        public BounceSingleQuery addVisibleField(string field)
        {
            if (field == null) { throw new System.ArgumentNullException("Parameter field is null."); }
            this.getFields().Add(field);
            return this;
        }

        public string getQueryParams()
        {
            string joinFields = "";
            if (getFields() != null && getFields().Any(x => true))
            {
                joinFields = string.Join(",", getFields());

                UriBuilder uriBuilder = new UriBuilder();
                uriBuilder.Query = "fields=" + joinFields;
                return uriBuilder.Query;
            }
            else
            {
                return "";
            }
        }
    }
}
