﻿using System.Web.Script.Serialization;
using Newtonsoft.Json;
using com.apifon.sdk.response;
using apifon_sdk_csharp.com.apifon.sdk.model;

namespace com.apifon.sdk.resource
{
    public class OTPResource : AbstractResource
    {
        public OTPResource() : base("/services/api/v1/otp")
        {

        }

        public OtpResponse Create(OtpRequest request)
        {
            JavaScriptSerializer json_serializer = new JavaScriptSerializer();

            this.SetCurMethod("POST");
            this.SetCurEndpoint(this.GetEndpoint() + "/create");
            this.SetCurBody(request.GetCreateBody());

            return JsonConvert.DeserializeObject<OtpResponse>(this.Dispatch());
        }

        public OtpVerifyResponse Verify(string reference, string otp)
        {
            JavaScriptSerializer json_serializer = new JavaScriptSerializer();

            this.SetCurMethod("POST");
            this.SetCurEndpoint(this.GetEndpoint() + "/verify/" + reference + "/" + otp);
            this.SetCurBody(null);

            return JsonConvert.DeserializeObject<OtpVerifyResponse>(this.Dispatch());
        }
    }
}
