﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.resource.helpers
{
    public class OpenIDScope
    {
        private readonly string scopeValue;

        private OpenIDScope(string scopeValue)
        {
            this.scopeValue = scopeValue;
        }

        public string getScopeValue()
        {
            return this.scopeValue;
        }


        public static OpenIDScope ACCOUNT_INFO { get { return new OpenIDScope("accountInfo"); } }
        public static OpenIDScope OPEN_ID { get { return new OpenIDScope("openid"); } }
        public static OpenIDScope READ_LANDING { get { return new OpenIDScope("readLanding"); } }
        public static OpenIDScope READ_LIST { get { return new OpenIDScope("readList"); } }
        public static OpenIDScope WRITE_LIST { get { return new OpenIDScope("writeList"); } }
        public static OpenIDScope READ_SUBSCRIBER { get { return new OpenIDScope("readSubscriber"); } }
        public static OpenIDScope WRITE_SUBSCRIBER { get { return new OpenIDScope("writeSubscriber"); } }
        public static OpenIDScope SMS_GATEWAY { get { return new OpenIDScope("smsGateway"); } }
        public static OpenIDScope IM_GATEWAY { get { return new OpenIDScope("imGateway"); } }
        public static OpenIDScope OTP_GATEWAY { get { return new OpenIDScope("otpGateway"); } }
       
    }
}
