﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.helpers
{
    public abstract class PaginatedRequest
    {
        protected int page = 1;
        protected int size = 20;
        protected string sortField = "id";
        protected SortDirection sortDir = SortDirection.ASC;

        public abstract string toQueryParamRequest();

        public abstract string getPathId();

        protected void addQueryParams(List<KeyValuePair<string, string>> queryParams)
        {
            queryParams.Add(new KeyValuePair<string, string>("size", size.ToString()));
            queryParams.Add(new KeyValuePair<string, string>("page", page.ToString()));
            queryParams.Add(new KeyValuePair<string, string>("sort", sortField));
            queryParams.Add(new KeyValuePair<string, string>("sort_dir", sortDir.ToString()));
        }
    }
}
