﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace apifon_sdk_csharp.com.apifon.sdk.helpers
{
    public abstract class PaginatedRequestBuilder : PaginatedRequest
    {
        public PaginatedRequestBuilder setPage(int page)
        {
            if (page< 0) {
                throw new System.ArgumentException("Parameter page must be a positive value.");
            }
            this.page = page;
            return this;
        }

        public PaginatedRequestBuilder setSize(int size)
        {
            if (size < 0) {
                throw new System.ArgumentException("Parameter size must be a positive value.");
            }
            this.size = size;
            return this;
        }

        public PaginatedRequestBuilder setSort(string sortField, SortDirection sortDirection)
        {

            if (string.IsNullOrEmpty(sortField)) { throw new System.ArgumentNullException("Parameter sortField is null."); }
            if (string.IsNullOrEmpty(sortDirection.ToString())) { throw new System.ArgumentNullException("Parameter sortDirection is null"); }

            this.sortDir = sortDirection;
            this.sortField = sortField;
            return this;
        }

        public abstract PaginatedRequest build();
    }
}
